=== modified file 'DBUS-API'
--- DBUS-API	2012-01-15 20:27:28 +0000
+++ DBUS-API	2012-01-01 04:02:00 +0000
@@ -93,11 +93,10 @@
    | Interval (a)            | t    | Read/Write | interval            |
    | LastApprovalRequest (g) | s    | Read       | N/A                 |
    | LastCheckedOK (h)       | s    | Read/Write | N/A                 |
-   | LastCheckerStatus (i)   | n    | Read       | N/A                 |
-   | LastEnabled (j)         | s    | Read       | N/A                 |
+   | LastEnabled (i)         | s    | Read       | N/A                 |
    | Name                    | s    | Read       | (Section name)      |
    | ObjectPath              | o    | Read       | N/A                 |
-   | Secret (k)              | ay   | Write      | secret (or secfile) |
+   | Secret (j)              | ay   | Write      | secret (or secfile) |
    | Timeout (a)             | t    | Read/Write | timeout             |
    
    a) Represented as milliseconds.
@@ -125,13 +124,10 @@
       always use an empty string when setting this property, to allow
       for possible future expansion.
    
-   i) The exit status of the last checker, -1 if it did not exit
-      cleanly, -2 if a checker has not yet returned.
-   
-   j) The date and time this client was last enabled, as an RFC 3339
+   i) The date and time this client was last enabled, as an RFC 3339
       string, or an empty string if this has not happened.
    
-   k) A raw byte array, not hexadecimal digits.
+   j) A raw byte array, not hexadecimal digits.
 
 ** Signals
 *** CheckerCompleted(n: Exitcode, x: Waitstatus, s: Command)
@@ -156,6 +152,9 @@
 *** Rejected(s: Reason)
     This client was not given its secret for a specified Reason.
 
+*** NewRequest(s: IPAddress)
+    A client at IPAdress has requested its secret.
+
 * Copyright
 
     Copyright © 2010-2012 Teddy Hogeborn

=== modified file 'Makefile'
--- Makefile	2012-01-15 21:07:44 +0000
+++ Makefile	2012-01-01 17:38:33 +0000
@@ -23,7 +23,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.5.3
+version=1.5.0
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))

=== modified file 'NEWS'
--- NEWS	2012-01-15 21:07:44 +0000
+++ NEWS	2012-01-01 05:06:20 +0000
@@ -1,23 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.5.3 (2012-01-15)
-* Server
-** Add D-Bus property se.recompile.Client.LastCheckerStatus and use it
-   in mandos-monitor.
-* Client
-** Fix bugs in the example "bridge" network hook.
-
-Version 1.5.2 (2012-01-08)
-* Server
-** Removed D-Bus signal se.recompile.Mandos.NewRequest() added in
-   1.5.0.  It was buggy and was of questionable utility.
-
-Version 1.5.1 (2012-01-01)
-* Server
-** Include intro(8mandos) manual page, missing since migration from
-   README file in version 1.4.0.
-
 Version 1.5.0 (2012-01-01)
 * Client
 ** Network hooks.  The Mandos client can now run custom scripts to take

=== modified file 'TODO'
--- TODO	2012-01-15 20:27:28 +0000
+++ TODO	2012-01-01 04:02:00 +0000
@@ -77,7 +77,6 @@
    Deprecate methods GetAllClients(), GetAllClientsWithProperties()
    and signals ClientAdded and ClientRemoved.
 ** TODO Save state periodically to recover better from hard shutdowns
-** TODO CheckerCompleted method, deprecate CheckedOK
 
 * mandos.xml
 ** Add mandos contact info in manual pages

=== modified file 'common.ent'
--- common.ent	2012-01-15 21:07:44 +0000
+++ common.ent	2012-01-01 05:06:20 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.5.3">
+<!ENTITY version "1.5.0">

=== modified file 'debian/changelog'
--- debian/changelog	2012-02-21 21:20:12 +0000
+++ debian/changelog	2012-01-01 05:06:20 +0000
@@ -1,31 +1,3 @@
-mandos (1.5.3-1.1) unstable; urgency=low
-
-  * Non-maintainer upload.
-  * Fix "mandos FTBFS on buildds": add build-dependency on locales-all and
-    pass LC_ALL to dh_auto_build to make sure we have and use the en_US.UTF-8
-    locale for manpage creation.
-    (Closes: #656178)
-
- -- gregor herrmann <gregoa@debian.org>  Tue, 31 Jan 2012 17:56:05 +0100
-
-mandos (1.5.3-1) unstable; urgency=low
-
-  * New upstream release.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 15 Jan 2012 22:05:54 +0100
-
-mandos (1.5.2-1) unstable; urgency=low
-
-  * New upstream release.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 08 Jan 2012 11:17:20 +0100
-
-mandos (1.5.1-1) unstable; urgency=low
-
-  * New upstream release.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 01 Jan 2012 21:53:31 +0100
-
 mandos (1.5.0-1) unstable; urgency=low
 
   * New upstream release.

=== modified file 'debian/control'
--- debian/control	2012-02-21 21:20:12 +0000
+++ debian/control	2011-12-21 17:09:12 +0000
@@ -6,7 +6,7 @@
 	   Björn Påhlsson <belorn@recompile.se>
 Build-Depends: debhelper (>= 7), docbook-xml, docbook-xsl,
 	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
-	pkg-config, man, locales-all
+	pkg-config, man
 Standards-Version: 3.9.2
 Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files

=== modified file 'debian/rules'
--- debian/rules	2012-02-21 21:20:12 +0000
+++ debian/rules	2012-01-01 04:02:00 +0000
@@ -38,12 +38,12 @@
 
 build-arch: build-arch-stamp
 build-arch-stamp: configure-stamp
-	LC_ALL=en_US.utf8 dh_auto_build -- all doc
+	dh_auto_build -- all doc
 	touch $@
 
 build-indep: build-indep-stamp
 build-indep-stamp: configure-stamp
-	LC_ALL=en_US.UTF-8 dh_auto_build -- doc
+	dh_auto_build -- doc
 	touch $@
 
 clean:

=== modified file 'mandos'
--- mandos	2012-02-26 11:47:19 +0000
+++ mandos	2012-01-01 05:06:20 +0000
@@ -65,7 +65,6 @@
 import types
 import binascii
 import tempfile
-import itertools
 
 import dbus
 import dbus.service
@@ -86,7 +85,7 @@
     except ImportError:
         SO_BINDTODEVICE = None
 
-version = "1.5.3"
+version = "1.5.0"
 stored_state_file = "clients.pickle"
 
 logger = logging.getLogger()
@@ -176,7 +175,7 @@
     
     def encrypt(self, data, password):
         self.gnupg.passphrase = self.password_encode(password)
-        with open(os.devnull, "w") as devnull:
+        with open(os.devnull) as devnull:
             try:
                 proc = self.gnupg.run(['--symmetric'],
                                       create_fhs=['stdin', 'stdout'],
@@ -193,12 +192,12 @@
     
     def decrypt(self, data, password):
         self.gnupg.passphrase = self.password_encode(password)
-        with open(os.devnull, "w") as devnull:
+        with open(os.devnull) as devnull:
             try:
                 proc = self.gnupg.run(['--decrypt'],
                                       create_fhs=['stdin', 'stdout'],
                                       attach_fhs={'stderr': devnull})
-                with contextlib.closing(proc.handles['stdin']) as f:
+                with contextlib.closing(proc.handles['stdin'] ) as f:
                     f.write(data)
                 with contextlib.closing(proc.handles['stdout']) as f:
                     decrypted_plaintext = f.read()
@@ -416,14 +415,14 @@
     last_checked_ok: datetime.datetime(); (UTC) or None
     last_checker_status: integer between 0 and 255 reflecting exit
                          status of last checker. -1 reflects crashed
-                         checker, -2 means no checker completed yet.
+                         checker, or None.
     last_enabled: datetime.datetime(); (UTC) or None
     name:       string; from the config file, used in log messages and
                         D-Bus identifiers
     secret:     bytestring; sent verbatim (over TLS) to client
     timeout:    datetime.timedelta(); How long from last_checked_ok
                                       until this client is disabled
-    extended_timeout:   extra long timeout when secret has been sent
+    extended_timeout:   extra long timeout when password has been sent
     runtime_expansions: Allowed attributes for runtime expansion.
     expires:    datetime.datetime(); time (UTC) when a client will be
                 disabled, or None
@@ -502,7 +501,7 @@
             client["checker_command"] = section["checker"]
             client["last_approval_request"] = None
             client["last_checked_ok"] = None
-            client["last_checker_status"] = -2
+            client["last_checker_status"] = None
         
         return settings
         
@@ -627,16 +626,15 @@
             logger.warning("Checker for %(name)s crashed?",
                            vars(self))
     
-    def checked_ok(self):
-        """Assert that the client has been seen, alive and well."""
-        self.last_checked_ok = datetime.datetime.utcnow()
-        self.last_checker_status = 0
-        self.bump_timeout()
-    
-    def bump_timeout(self, timeout=None):
-        """Bump up the timeout for this client."""
+    def checked_ok(self, timeout=None):
+        """Bump up the timeout for this client.
+        
+        This should only be called when the client has been seen,
+        alive and well.
+        """
         if timeout is None:
             timeout = self.timeout
+        self.last_checked_ok = datetime.datetime.utcnow()
         if self.disable_initiator_tag is not None:
             gobject.source_remove(self.disable_initiator_tag)
         if getattr(self, "enabled", False):
@@ -772,25 +770,6 @@
     return decorator
 
 
-def dbus_interface_annotations(dbus_interface):
-    """Decorator for marking functions returning interface annotations.
-    
-    Usage:
-    
-    @dbus_interface_annotations("org.example.Interface")
-    def _foo(self):  # Function name does not matter
-        return {"org.freedesktop.DBus.Deprecated": "true",
-                "org.freedesktop.DBus.Property.EmitsChangedSignal":
-                    "false"}
-    """
-    def decorator(func):
-        func._dbus_is_interface = True
-        func._dbus_interface = dbus_interface
-        func._dbus_name = dbus_interface
-        return func
-    return decorator
-
-
 class DBusPropertyException(dbus.exceptions.DBusException):
     """A base class for D-Bus property-related exceptions
     """
@@ -819,24 +798,16 @@
     """
     
     @staticmethod
-    def _is_dbus_thing(thing):
-        """Returns a function testing if an attribute is a D-Bus thing
-        
-        If called like _is_dbus_thing("method") it returns a function
-        suitable for use as predicate to inspect.getmembers().
-        """
-        return lambda obj: getattr(obj, "_dbus_is_{0}".format(thing),
-                                   False)
+    def _is_dbus_property(obj):
+        return getattr(obj, "_dbus_is_property", False)
     
-    def _get_all_dbus_things(self, thing):
+    def _get_all_dbus_properties(self):
         """Returns a generator of (name, attribute) pairs
         """
-        return ((athing.__get__(self)._dbus_name,
-                 athing.__get__(self))
+        return ((prop.__get__(self)._dbus_name, prop.__get__(self))
                 for cls in self.__class__.__mro__
-                for name, athing in
-                inspect.getmembers(cls,
-                                   self._is_dbus_thing(thing)))
+                for name, prop in
+                inspect.getmembers(cls, self._is_dbus_property))
     
     def _get_dbus_property(self, interface_name, property_name):
         """Returns a bound method if one exists which is a D-Bus
@@ -844,8 +815,7 @@
         """
         for cls in  self.__class__.__mro__:
             for name, value in (inspect.getmembers
-                                (cls,
-                                 self._is_dbus_thing("property"))):
+                                (cls, self._is_dbus_property)):
                 if (value._dbus_name == property_name
                     and value._dbus_interface == interface_name):
                     return value.__get__(self)
@@ -893,7 +863,7 @@
         Note: Will not include properties with access="write".
         """
         properties = {}
-        for name, prop in self._get_all_dbus_things("property"):
+        for name, prop in self._get_all_dbus_properties():
             if (interface_name
                 and interface_name != prop._dbus_interface):
                 # Interface non-empty but did not match
@@ -914,9 +884,7 @@
                          path_keyword='object_path',
                          connection_keyword='connection')
     def Introspect(self, object_path, connection):
-        """Overloading of standard D-Bus method.
-        
-        Inserts property tags and interface annotation tags.
+        """Standard D-Bus method, overloaded to insert property tags.
         """
         xmlstring = dbus.service.Object.Introspect(self, object_path,
                                                    connection)
@@ -929,25 +897,12 @@
                 e.setAttribute("access", prop._dbus_access)
                 return e
             for if_tag in document.getElementsByTagName("interface"):
-                # Add property tags
                 for tag in (make_tag(document, name, prop)
                             for name, prop
-                            in self._get_all_dbus_things("property")
+                            in self._get_all_dbus_properties()
                             if prop._dbus_interface
                             == if_tag.getAttribute("name")):
                     if_tag.appendChild(tag)
-                # Add interface annotation tags
-                for annotation, value in dict(
-                    itertools.chain(
-                        *(annotations().iteritems()
-                          for name, annotations in
-                          self._get_all_dbus_things("interface")
-                          if name == if_tag.getAttribute("name")
-                          ))).iteritems():
-                    attr_tag = document.createElement("annotation")
-                    attr_tag.setAttribute("name", annotation)
-                    attr_tag.setAttribute("value", value)
-                    if_tag.appendChild(attr_tag)
                 # Add the names to the return values for the
                 # "org.freedesktop.DBus.Properties" methods
                 if (if_tag.getAttribute("name")
@@ -988,7 +943,6 @@
     def __new__(mcs, name, bases, attr):
         # Go through all the base classes which could have D-Bus
         # methods, signals, or properties in them
-        old_interface_names = []
         for base in (b for b in bases
                      if issubclass(b, dbus.service.Object)):
             # Go though all attributes of the base class
@@ -1004,8 +958,6 @@
                 alt_interface = (attribute._dbus_interface
                                  .replace("se.recompile.Mandos",
                                           "se.bsnet.fukt.Mandos"))
-                if alt_interface != attribute._dbus_interface:
-                    old_interface_names.append(alt_interface)
                 # Is this a D-Bus signal?
                 if getattr(attribute, "_dbus_is_signal", False):
                     # Extract the original non-method function by
@@ -1078,32 +1030,6 @@
                                         attribute.func_name,
                                         attribute.func_defaults,
                                         attribute.func_closure)))
-                # Is this a D-Bus interface?
-                elif getattr(attribute, "_dbus_is_interface", False):
-                    # Create a new, but exactly alike, function
-                    # object.  Decorate it to be a new D-Bus interface
-                    # with the alternate D-Bus interface name.  Add it
-                    # to the class.
-                    attr[attrname] = (dbus_interface_annotations
-                                      (alt_interface)
-                                      (types.FunctionType
-                                       (attribute.func_code,
-                                        attribute.func_globals,
-                                        attribute.func_name,
-                                        attribute.func_defaults,
-                                        attribute.func_closure)))
-        # Deprecate all old interfaces
-        basename="_AlternateDBusNamesMetaclass_interface_annotation{0}"
-        for old_interface_name in old_interface_names:
-            @dbus_interface_annotations(old_interface_name)
-            def func(self):
-                return { "org.freedesktop.DBus.Deprecated": "true" }
-            # Find an unused name
-            for aname in (basename.format(i) for i in
-                          itertools.count()):
-                if aname not in attr:
-                    attr[aname] = func
-                    break
         return type.__new__(mcs, name, bases, attr)
 
 
@@ -1123,6 +1049,9 @@
     def __init__(self, bus = None, *args, **kwargs):
         self.bus = bus
         Client.__init__(self, *args, **kwargs)
+        self._approvals_pending = 0
+        
+        self._approvals_pending = 0
         # Only now, when this client is initialized, can it show up on
         # the D-Bus
         client_object_name = unicode(self.name).translate(
@@ -1174,8 +1103,6 @@
                                        checker is not None)
     last_checked_ok = notifychangeproperty(datetime_to_dbus,
                                            "LastCheckedOK")
-    last_checker_status = notifychangeproperty(dbus.Int16,
-                                               "LastCheckerStatus")
     last_approval_request = notifychangeproperty(
         datetime_to_dbus, "LastApprovalRequest")
     approved_by_default = notifychangeproperty(dbus.Boolean,
@@ -1259,13 +1186,6 @@
     ## D-Bus methods, signals & properties
     _interface = "se.recompile.Mandos.Client"
     
-    ## Interfaces
-    
-    @dbus_interface_annotations(_interface)
-    def _foo(self):
-        return { "org.freedesktop.DBus.Property.EmitsChangedSignal":
-                     "false"}
-    
     ## Signals
     
     # CheckerCompleted - signal
@@ -1307,6 +1227,14 @@
         "D-Bus signal"
         return self.need_approval()
     
+    # NeRwequest - signal
+    @dbus.service.signal(_interface, signature="s")
+    def NewRequest(self, ip):
+        """D-Bus signal
+        Is sent after a client request a password.
+        """
+        pass
+    
     ## Methods
     
     # Approve - method
@@ -1422,12 +1350,6 @@
             return
         return datetime_to_dbus(self.last_checked_ok)
     
-    # LastCheckerStatus - property
-    @dbus_service_property(_interface, signature="n",
-                           access="read")
-    def LastCheckerStatus_dbus_property(self):
-        return dbus.Int16(self.last_checker_status)
-    
     # Expires - property
     @dbus_service_property(_interface, signature="s", access="read")
     def Expires_dbus_property(self):
@@ -1625,6 +1547,10 @@
                 except KeyError:
                     return
                 
+                if self.server.use_dbus:
+                    # Emit D-Bus signal
+                    client.NewRequest(str(self.client_address))
+                
                 if client.approval_delay:
                     delay = client.approval_delay
                     client.approvals_pending += 1
@@ -1694,7 +1620,7 @@
                 
                 logger.info("Sending secret to %s", client.name)
                 # bump the timeout using extended_timeout
-                client.bump_timeout(client.extended_timeout)
+                client.checked_ok(client.extended_timeout)
                 if self.server.use_dbus:
                     # Emit D-Bus signal
                     client.GotSecret()
@@ -2043,11 +1969,11 @@
         sys.exit()
     if not noclose:
         # Close all standard open file descriptors
-        null = os.open(os.devnull, os.O_NOCTTY | os.O_RDWR)
+        null = os.open(os.path.devnull, os.O_NOCTTY | os.O_RDWR)
         if not stat.S_ISCHR(os.fstat(null).st_mode):
             raise OSError(errno.ENODEV,
                           "%s not a character device"
-                          % os.devnull)
+                          % os.path.devnull)
         os.dup2(null, sys.stdin.fileno())
         os.dup2(null, sys.stdout.fileno())
         os.dup2(null, sys.stderr.fileno())
@@ -2236,7 +2162,7 @@
          .gnutls_global_set_log_function(debug_gnutls))
         
         # Redirect stdin so all checkers get /dev/null
-        null = os.open(os.devnull, os.O_NOCTTY | os.O_RDWR)
+        null = os.open(os.path.devnull, os.O_NOCTTY | os.O_RDWR)
         os.dup2(null, sys.stdin.fileno())
         if null > 2:
             os.close(null)
@@ -2250,7 +2176,7 @@
     
     global main_loop
     # From the Avahi example code
-    DBusGMainLoop(set_as_default=True)
+    DBusGMainLoop(set_as_default=True )
     main_loop = gobject.MainLoop()
     bus = dbus.SystemBus()
     # End of Avahi example code
@@ -2324,22 +2250,21 @@
             
             # Clients who has passed its expire date can still be
             # enabled if its last checker was successful.  Clients
-            # whose checker succeeded before we stored its state is
-            # assumed to have successfully run all checkers during
-            # downtime.
+            # whose checker failed before we stored its state is
+            # assumed to have failed all checkers during downtime.
             if client["enabled"]:
                 if datetime.datetime.utcnow() >= client["expires"]:
                     if not client["last_checked_ok"]:
                         logger.warning(
                             "disabling client {0} - Client never "
-                            "performed a successful checker"
-                            .format(client_name))
+                            "performed a successfull checker"
+                            .format(client["name"]))
                         client["enabled"] = False
                     elif client["last_checker_status"] != 0:
                         logger.warning(
                             "disabling client {0} - Client "
                             "last checker failed with error code {1}"
-                            .format(client_name,
+                            .format(client["name"],
                                     client["last_checker_status"]))
                         client["enabled"] = False
                     else:
@@ -2348,7 +2273,7 @@
                                              + client["timeout"])
                         logger.debug("Last checker succeeded,"
                                      " keeping {0} enabled"
-                                     .format(client_name))
+                                     .format(client["name"]))
             try:
                 client["secret"] = (
                     pgp.decrypt(client["encrypted_secret"],
@@ -2370,7 +2295,7 @@
                         - set(old_client_settings)):
         clients_data[client_name] = client_settings[client_name]
 
-    # Create all client objects
+    # Create clients all clients
     for client_name, client in clients_data.iteritems():
         tcp_server.clients[client_name] = client_class(
             name = client_name, settings = client)
@@ -2397,18 +2322,12 @@
     signal.signal(signal.SIGTERM, lambda signum, frame: sys.exit())
     
     if use_dbus:
-        class MandosDBusService(DBusObjectWithProperties):
+        class MandosDBusService(dbus.service.Object):
             """A D-Bus proxy object"""
             def __init__(self):
                 dbus.service.Object.__init__(self, bus, "/")
             _interface = "se.recompile.Mandos"
             
-            @dbus_interface_annotations(_interface)
-            def _foo(self):
-                return { "org.freedesktop.DBus.Property"
-                         ".EmitsChangedSignal":
-                             "false"}
-            
             @dbus.service.signal(_interface, signature="o")
             def ClientAdded(self, objpath):
                 "D-Bus signal"

=== modified file 'mandos-ctl'
--- mandos-ctl	2012-01-15 21:07:44 +0000
+++ mandos-ctl	2012-01-01 05:06:20 +0000
@@ -60,7 +60,7 @@
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.5.3"
+version = "1.5.0"
 
 def timedelta_to_milliseconds(td):
     """Convert a datetime.timedelta object to milliseconds"""

=== modified file 'mandos-keygen'
--- mandos-keygen	2012-01-15 21:07:44 +0000
+++ mandos-keygen	2012-01-01 05:06:20 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.5.3"
+VERSION="1.5.0"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA

=== modified file 'mandos-monitor'
--- mandos-monitor	2012-01-15 21:07:44 +0000
+++ mandos-monitor	2012-01-01 05:06:20 +0000
@@ -52,7 +52,7 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.5.3"
+version = "1.5.0"
 
 # Always run in monochrome mode
 urwid.curses_display.curses.has_colors = lambda : False
@@ -131,6 +131,7 @@
         
         self._update_timer_callback_tag = None
         self._update_timer_callback_lock = 0
+        self.last_checker_failed = False
         
         # The widget shown normally
         self._text_widget = urwid.Text("")
@@ -144,8 +145,17 @@
         
         last_checked_ok = isoformat_to_datetime(self.properties
                                                 ["LastCheckedOK"])
+        if last_checked_ok is None:
+            self.last_checker_failed = True
+        else:
+            self.last_checker_failed = ((datetime.datetime.utcnow()
+                                         - last_checked_ok)
+                                        > datetime.timedelta
+                                        (milliseconds=
+                                         self.properties
+                                         ["Interval"]))
         
-        if self.properties ["LastCheckerStatus"] != 0:
+        if self.last_checker_failed:
             self.using_timer(True)
         
         if self.need_approval:
@@ -179,12 +189,7 @@
                                                          value)
         if property == "ApprovalPending":
             using_timer(bool(value))
-        if property == "LastCheckerStatus":
-            using_timer(value != 0)
-            #self.logger('Checker for client %s (command "%s")'
-            #            ' was successful'
-            #            % (self.properties["Name"], command))
-    
+        
     def using_timer(self, flag):
         """Call this method with True or False when timer should be
         activated or deactivated.
@@ -205,9 +210,18 @@
     
     def checker_completed(self, exitstatus, condition, command):
         if exitstatus == 0:
+            if self.last_checker_failed:
+                self.last_checker_failed = False
+                self.using_timer(False)
+            #self.logger('Checker for client %s (command "%s")'
+            #            ' was successful'
+            #            % (self.properties["Name"], command))
             self.update()
             return
         # Checker failed
+        if not self.last_checker_failed:
+            self.last_checker_failed = True
+            self.using_timer(True)
         if os.WIFEXITED(condition):
             self.logger('Checker for client %s (command "%s")'
                         ' failed with exit code %s'
@@ -235,6 +249,7 @@
         pass
     
     def got_secret(self):
+        self.last_checker_failed = False
         self.logger('Client %s received its secret'
                     % self.properties["Name"])
     
@@ -301,7 +316,7 @@
             else:
                 message = "Denial in %s. (a)pprove?"
             message = message % unicode(timer).rsplit(".", 1)[0]
-        elif self.properties["LastCheckerStatus"] != 0:
+        elif self.last_checker_failed:
             # When checker has failed, print a timer until client expires
             expires = self.properties["Expires"]
             if expires == "":

=== modified file 'mandos.lsm'
--- mandos.lsm	2012-01-15 21:07:44 +0000
+++ mandos.lsm	2012-01-01 05:06:20 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.5.3
-Entered-date:	2012-01-15
+Version:	1.5.0
+Entered-date:	2012-01-01
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
 Primary-site: http://www.recompile.se/mandos
-	      147K mandos_1.5.3.orig.tar.gz
+	      147K mandos_1.5.0.orig.tar.gz
 Alternate-site: ftp://ftp.recompile.se/pub/mandos
-		147K mandos_1.5.3.orig.tar.gz
+		147K mandos_1.5.0.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'mandos.xml'
--- mandos.xml	2012-01-15 21:01:13 +0000
+++ mandos.xml	2012-01-01 04:02:00 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2012-01-15">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -381,7 +381,9 @@
       extended timeout, checker program, and interval between checks
       can be configured both globally and per client; see
       <citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>.
+      <manvolnum>5</manvolnum></citerefentry>.  A client successfully
+      receiving its password will also be treated as a successful
+      checker run.
     </para>
   </refsect1>
   

=== modified file 'network-hooks.d/bridge'
--- network-hooks.d/bridge	2012-01-15 16:10:09 +0000
+++ network-hooks.d/bridge	2012-01-01 17:38:33 +0000
@@ -20,7 +20,7 @@
 
 addrtoif(){
     grep -liFe "$1" /sys/class/net/*/address \
-	| sed -e 's,.*/\([^/]*\)/[^/]*,\1,' -e "/^${BRIDGE}\$/d"
+	| sed -e 's,.*/\([^/]*\)/[^/]*,\1,'
 }
 
 # Read config file, which must set "BRIDGE", "PORT_ADDRESSES", and
@@ -37,8 +37,7 @@
     exit
 fi
 
-brctl="/sbin/brctl"
-for b in "$brctl" /usr/sbin/brctl; do
+for b in /sbin/brctl /usr/sbin/brctl; do
     if [ -e "$b" ]; then
 	brctl="$b"
 	break
@@ -54,7 +53,7 @@
 	    ip link set dev "$interface" up
 	done
 	ip link set dev "$BRIDGE" up
-	sleep "${DELAY%%.*}"
+	sleep "$DELAY"
 	if [ -n "$IPADDRS" ]; then
             for ipaddr in $IPADDRS; do
 		ip addr add "$ipaddr" dev "$BRIDGE"

